给你一棵所有节点为非负值的二叉搜索树，请你计算树中任意两节点的差的绝对值的最小值。

**示例：**
```
输入：
   1
    \
     3
    /
   2
输出：
1
解释：
最小绝对差为 1，其中 2 和 1 的差的绝对值为 1（或者 2 和 3）。
```

**提示：**

- 树中至少有 2 个节点。
- 本题与 783 https://leetcode-cn.com/problems/minimum-distance-between-bst-nodes/ 相同

通过次数`26,113`&ensp;|&ensp;提交次数`44,070`

**代码实现**
```python
# Definition for a binary tree node.
class TreeNode:
    def __init__(self, x):
        self.val = x
        self.left = None
        self.right = None

class Solution:
    def getMinimumDifference(self, root: TreeNode) -> int:
        self.mins = sys.maxsize
        cur = None
        def mid_sort(root: TreeNode) -> None:
            nonlocal cur
            if root!=None:
                mid_sort(root.left)
                if cur==None:
                    cur = root.val
                else:
                    self.mins = min(self.mins, root.val-cur)
                    cur = root.val
                mid_sort(root.right)
        mid_sort(root)
        return self.mins
```

```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/minimum-absolute-difference-in-bst
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
