视频游戏“辐射4”中，任务“通向自由”要求玩家到达名为“Freedom Trail Ring”的金属表盘，并使用表盘拼写特定关键词才能开门。

给定一个字符串 `ring`，表示刻在外环上的编码；给定另一个字符串 `key`，表示需要拼写的关键词。您需要算出能够拼写关键词中所有字符的最少步数。

最初，`ring` 的第一个字符与`12:00`方向对齐。您需要顺时针或逆时针旋转` ring` 以使 `key` 的一个字符在 `12:00 `方向对齐，然后按下中心按钮，以此逐个拼写完` key `中的所有字符。

旋转 `ring` 拼出 `key` 字符` key[i] `的阶段中：

1. 您可以将 `ring` 顺时针或逆时针旋转一个位置，计为`1`步。旋转的最终目的是将字符串 `ring` 的一个字符与 `12:00 `方向对齐，并且这个字符必须等于字符 `key[i]` 。
2. 如果字符` key[i] `已经对齐到`12:00`方向，您需要按下中心按钮进行拼写，这也将算作 `1` 步。按完之后，您可以开始拼写 `key `的下一个字符（下一阶段）, 直至完成所有拼写。

**示例：**

 ![在这里插入图片描述](https://img-blog.csdnimg.cn/20201111093509976.png?x-oss-process=image/watermark,type_ZmFuZ3poZW5naGVpdGk,shadow_10,text_aHR0cHM6Ly9ibG9nLmNzZG4ubmV0L2poYW9z,size_16,color_FFFFFF,t_70#pic_center)
 ```
输入: ring = "godding", key = "gd"
输出: 4
解释:
 对于 key 的第一个字符 'g'，已经在正确的位置, 我们只需要1步来拼写这个字符。 
 对于 key 的第二个字符 'd'，我们需要逆时针旋转 ring "godding" 2步使它变成 "ddinggo"。
 当然, 我们还需要1步进行拼写。
 因此最终的输出是 4。
```

**提示：**

- `ring` 和 `key` 的字符串长度取值范围均为 `1` 至 `100`；
- 两个字符串中都只有小写字符，并且均可能存在重复字符；
- 字符串` key `一定可以由字符串` ring` 旋转拼出。

通过次数`3,660`&ensp;|&ensp;提交次数`7,916`

**代码实现**
```python
class Solution:
    def findRotateSteps(self, ring: str, key: str) -> int:
        store = [[0]*len(ring) for _ in range(len(ring))]
        dic = defaultdict(list)
        for i in range(len(ring)):
            dic[ring[i]].append(i)
            for j in range(i + 1, len(ring)):
                a, b = j - i, i + len(ring) - j
                if a<b:
                    store[i][j] = a
                    store[j][i] = a
                else:
                    store[i][j] = b
                    store[j][i] = b
        @functools.lru_cache(None)
        def proc(b, idx):
            if idx == len(key):
                return 0
            re = float('inf')
            for i in dic[key[idx]]:
                re = min(re, proc(i, idx + 1) + 1 + store[b][i])
            return re
        re = proc(0, 0)
        return re
```

```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/freedom-trail
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
