给定一个数组 `nums`，编写一个函数将所有 `0 `移动到数组的末尾，同时保持非零元素的相对顺序。

**示例:**
```
输入: [0,1,0,3,12]
输出: [1,3,12,0,0]
```

**说明:**

- 必须在原数组上操作，不能拷贝额外的数组。
- 尽量减少操作次数。

通过次数`247,393`&ensp;|&ensp;提交次数`392,424`

**代码实现**

- 栈方法
```python
class Solution:
    def moveZeroes(self, nums: List[int]) -> None:
        """
        Do not return anything, modify nums in-place instead.
        """
        for i in range(nums.count(0)):
            nums.remove(0)
            nums.append(0)
```

- 遍历修改法
```python
class Solution:
    def moveZeroes(self, nums: List[int]) -> None:
        """
        Do not return anything, modify nums in-place instead.
        """
        c = 0
        for i in nums:
            if i != 0:
                nums[c] = i
                c += 1
        for i in range(c, len(nums)):
            nums[i] = 0
```
```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/move-zeroes
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
