给定一个整数数组 `A`，如果它是有效的山脉数组就返回 `true`，否则返回 `false`。

让我们回顾一下，如果 `A` 满足下述条件，那么它是一个山脉数组：

-  `A.length >= 3`
-  在 `0 < i < A.length - 1` 条件下，存在 `i` 使得：
       -  `A[0] < A[1] < ... A[i-1] < A[i]`
       -  `A[i] > A[i+1] > ... > A[A.length - 1]`
![在这里插入图片描述](https://img-blog.csdnimg.cn/20201103101804892.png?x-oss-process=image/watermark,type_ZmFuZ3poZW5naGVpdGk,shadow_10,text_aHR0cHM6Ly9ibG9nLmNzZG4ubmV0L2poYW9z,size_16,color_FFFFFF,t_70#pic_center)




**示例 1：**
```
输入：[2,1]
输出：false
```

**示例 2：**
```
输入：[3,5,5]
输出：false
```

**示例 3：**
```
输入：[0,3,2,1]
输出：true
```

**提示：**

- `0 <= A.length <= 10000`
- `0 <= A[i] <= 10000 `
 
通过次数`23,568`&ensp;|&ensp;提交次数`61,278`

**代码实现**
```python
class Solution:
    def validMountainArray(self, A: List[int]) -> bool:
        idx, l = 1, len(A)
        if l < 3: return False
        while idx < l and A[idx] > A[idx-1]: idx+=1
        if (idx < l and A[idx] == A[idx-1]) or (idx >= l or idx <= 1): return False
        while idx < l and A[idx] < A[idx-1]: idx += 1
        return idx >= l
```

```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/valid-mountain-array
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
