给出一个无重叠的 ，按照区间起始端点排序的区间列表。

在列表中插入一个新的区间，你需要确保列表中的区间仍然有序且不重叠（如果有必要的话，可以合并区间）。

**示例 1：**
```
输入：intervals = [[1,3],[6,9]], newInterval = [2,5]
输出：[[1,5],[6,9]]
```
**示例 2：**
```
输入：intervals = [[1,2],[3,5],[6,7],[8,10],[12,16]], newInterval = [4,8]
输出：[[1,2],[3,10],[12,16]]
解释：这是因为新的区间 [4,8] 与 [3,5],[6,7],[8,10] 重叠。
```
 
通过次数`35,510`&ensp;|&ensp;提交次数`91,598`

**代码实现**
```python
class Solution:
    def insert(self, intervals: List[List[int]], newInterval: List[int]) -> List[List[int]]:
        re = []
        idx = 0
        intervals.append(newInterval)
        intervals.sort()
        for idx in range(len(intervals)):
            i = intervals[idx]
            if i[1]<newInterval[0]: re.append(i)
            elif newInterval[0] <= i[1] <= newInterval[1] or i[0] <= newInterval[1] <= i[1] or newInterval[0] <= i[0] <= newInterval[1] or i[0] <= newInterval[0] <= i[1]:
                newInterval[0] = min(newInterval[0], i[0])
                newInterval[1] = max(newInterval[1], i[1])
            else:
                re.append(newInterval)
                re.append(i)
                break
        else:
            if len(re)==0 or newInterval[0]>re[-1][1]: re.append(newInterval)
        re = re + intervals[idx+1:]
        return re
```

```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/insert-interval
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
