给定一个链表，删除链表的倒数第 `n `个节点，并且返回链表的头结点。

**示例：**
```
给定一个链表: 1->2->3->4->5, 和 n = 2.
当删除了倒数第二个节点后，链表变为 1->2->3->5.
```
**说明：**
给定的 `n` 保证是有效的。

**进阶：**
- 你能尝试使用一趟扫描实现吗？

通过次数`259,946`&ensp;|&ensp;提交次数`648,405`
**代码实现**

- 两趟扫描
```python
# Definition for singly-linked list.
class ListNode:
    def __init__(self, x):
        self.val = x
        self.next = None

class Solution:
    def removeNthFromEnd(self, head: ListNode, n: int) -> ListNode:
        if n==0:
            return head
        temp2 = head
        temp1 = temp2
        nums = 0
        while temp1 != None:
            temp1=temp1.next
            nums+=1
        nums = nums-n
        if nums==0:
            return head.next
        while nums >0:
            nums-=1
            if nums==0:
                temp2.next = temp2.next.next
                break
            temp2 = temp2.next
        return head
```

- 一趟扫描
```python
# Definition for singly-linked list.
class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next
        
class Solution:
    def removeNthFromEnd(self, head: ListNode, n: int) -> ListNode:
        temp = ListNode(0)
        temp.next = head
        cur, dels = temp, head
        for i in range(n):
            dels = dels.next
        while dels:
            cur = cur.next
            dels = dels.next
        cur.next = cur.next.next
        return temp.next
```

```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/remove-nth-node-from-end-of-list
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
