给出两个 `非空` 的链表用来表示两个非负的整数。其中，它们各自的位数是按照 `逆序` 的方式存储的，并且它们的每个节点只能存储 `一位` 数字。
如果，我们将这两个数相加起来，则会返回一个新的链表来表示它们的和。
您可以假设除了数字 `0` 之外，这两个数都不会以 `0` 开头。
**示例：**
```
输入：(2 -> 4 -> 3) + (5 -> 6 -> 4)
输出：7 -> 0 -> 8
原因：342 + 465 = 807
```
通过次数 `573,790` &ensp; &ensp; &ensp;提交次数 `1,495,145`
**代码实现**

```python
# Definition for singly-linked list.
class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next
        
class Solution:
    def addTwoNumbers(self, l1: ListNode, l2: ListNode) -> ListNode:
        red = 0
        res = ListNode()
        t = res
        while l1 or l2:
            cur = red
            if l1:
                cur += l1.val
                l1 = l1.next
            if l2:
                cur+= l2.val
                l2 = l2.next
            red = cur//10
            t.next = ListNode(cur%10)
            t = t.next
        if red:
            t.next=ListNode(red)
        return res.next
```
```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/add-two-numbers
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```

