给你两个数组，`arr1 `和 `arr2`，

- `arr2` 中的元素各不相同
- `arr2 `中的每个元素都出现在` arr1` 中

对 `arr1` 中的元素进行排序，使 `arr1` 中项的相对顺序和 `arr2` 中的相对顺序相同。未在 `arr2 `中出现过的元素需要按照升序放在 `arr1 `的末尾。

**示例：**
```
输入：arr1 = [2,3,1,3,2,4,6,7,9,2,19], arr2 = [2,1,4,3,9,6]
输出：[2,2,2,1,4,3,3,9,6,7,19]
```
 
**提示：**

- `arr1.length, arr2.length <= 1000`
- `0 <= arr1[i], arr2[i] <= 1000`
- `arr2` 中的元素 `arr2[i]` 各不相同
- `arr2 `中的每个元素 `arr2[i]` 都出现在` arr1` 中

通过次数`35,443`&ensp;|&ensp;提交次数`50,992`

**代码实现**
```python
class Solution:
    def relativeSortArray(self, arr1: List[int], arr2: List[int]) -> List[int]:
        from collections import Counter
        a1c = Counter(arr1)
        re = []
        for i in arr2:
            re.extend([i]*a1c[i])
            del a1c[i]
        temp = a1c.most_common()
        temp.sort(key = lambda x: x[0])
        for i,j in temp:
            re.extend([i]*j)
        return re
```

```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/relative-sort-array
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
