对链表进行插入排序。

![在这里插入图片描述](https://img-blog.csdnimg.cn/2020112010422671.png#pic_center)

插入排序的动画演示如上。从第一个元素开始，该链表可以被认为已经部分排序（用黑色表示）。
每次迭代时，从输入数据中移除一个元素（用红色表示），并原地将其插入到已排好序的链表中。

 

**插入排序算法：**

1. 插入排序是迭代的，每次只移动一个元素，直到所有元素可以形成一个有序的输出列表。
2. 每次迭代中，插入排序只从输入数据中移除一个待排序的元素，找到它在序列中适当的位置，并将其插入。
3. 重复直到所有输入数据插入完为止。

**示例 1：**
```
输入: 4->2->1->3
输出: 1->2->3->4
```

**示例 2：**
```
输入: -1->5->3->4->0
输出: -1->0->3->4->5
```
通过次数`49,568`&ensp;|&ensp;提交次数`74,732`

**代码实现**
```python
# Definition for singly-linked list.
class ListNode:
    def __init__(self, x):
        self.val = x
        self.next = None

class Solution:
    def insertionSortList(self, head: ListNode) -> ListNode:
        import sys
        o = ListNode(-sys.maxsize)
        p = o
        t = o
        cur = head
        while cur:
            if t.val < cur.val:
                t.next = cur
                t = cur
                cur = cur.next
            else:
                temp = cur.next
                t.next = temp
                while p.next and p.next.val < cur.val:
                    p = p.next
                cur.next = p.next
                p.next = cur
                p = o
                cur = temp
        return o.next
```
```
来源：力扣（LeetCode）
链接：https://leetcode-cn.com/problems/insertion-sort-list
著作权归领扣网络所有。商业转载请联系官方授权，非商业转载请注明出处。
```
